
var file = require('./file');

exports.SEPARATOR = '/';

exports.cwd = function () {
    throw Error("cwd not yet implemented.");
};

exports.list = function (path) {
    try { return Titanium.Filesystem.getFile(path).getDirectoryListing(); } catch (e) {}
    return [];
};

exports.canonical = function (path) {
    try { return Titanium.Filesystem.getFile(path).nativePath(); } catch (e) {}
    return [];
};

exports.exists = function (path) {
    try { return Titanium.Filesystem.getFile(path).exists(); } catch (e) {}
    return false;
};

// TODO necessary for lazy module reloading in sandboxes
exports.mtime = function (path) {
    var lastModified = Titanium.Filesystem.getFile(path).modificationTimestamp();

    if (lastModified === 0)
        return undefined;
    else
        return new Date(lastModified);
};

exports.size = function (path) {
    try { return Titanium.Filesystem.getFile(path).number(); } catch (e) {}
    return 0;
};

exports.stat = function (path) {
    return {
        mtime: exports.mtime(path),
        size: exports.size(path)
    }
};

exports.isDirectory = function (path) {
    try { return Titanium.Filesystem.getFile(path).isDirectory(); } catch (e) {}
    return false;
};

exports.isFile = function (path) {
    try { return Titanium.Filesystem.getFile(path).isFile(); } catch (e) {}
    return false;
};

exports.isLink = function (path) {
    try { return Titanium.Filesystem.getFile(path).isSymbolicLink(); } catch (e) {}
    return false;
};

exports.isReadable = function (path) {
    throw Error("isReadable not yet implemented.");
};

exports.isWritable = function (path) {
    throw Error("isWritable not yet implemented.");
};

exports.rename = function (source, target) {
    throw Error("rename not yet implemented.");
};

exports.move = function (source, target) {
    throw Error("move not yet implemented.");
};

exports.remove = function (path) {
    throw Error("remove not yet implemented.");
};

exports.mkdir = function (path) {
    throw Error("mkdir not yet implemented.");
};

exports.rmdir = function(path) {
    throw Error("rmdir not yet implemented.");
};

exports.touch = function (path, mtime) {
    throw Error("touch not yet implemented.");
};

// FIXME temporary hack
var fs_read = system.fs.read; // from bootstrap fixtures

exports.FileIO = function (path, mode, permissions) {
    mode = file.mode(mode);
    var read = mode.read,
        write = mode.write,
        append = mode.append,
        update = mode.update;

    if (update) {
        throw new Error("Updating IO not yet implemented.");
    } else if (write || append) {
        throw new Error("Writing IO not yet implemented.");
    } else if (read) {
        // FIXME temporary hack
        return {
            'read': function () {
                return fs_read(path);
            },
            'isatty': function() {
                return false;
            },
            'close': function () {
            }
        };
    } else {
        throw new Error("Files must be opened either for read, write, or update mode.");
    }
};

